Index: /trunk/src/wp-includes/js/mediaelement/mediaelement.js
===================================================================
--- /trunk/src/wp-includes/js/mediaelement/mediaelement.js	(revision 41876)
+++ /trunk/src/wp-includes/js/mediaelement/mediaelement.js	(revision 41877)
@@ -316,6 +316,6 @@
 		}
 
-		if (!/^[a-z]{2}(\-[a-z]{2})?$/i.test(args[0])) {
-			throw new TypeError('Language code must have format `xx` or `xx-xx`');
+		if (!/^(([a-z]{2}((\-|_)[a-z]{2})?)|([a-z]{3}))$/i.test(args[0])) {
+			throw new TypeError('Language code must have format `xx`, `xxx`, `xx_XX` or `xx-xx`');
 		}
 
@@ -865,7 +865,21 @@
 		try {
 			if (methodName === 'play' && t.mediaElement.rendererName === 'native_dash') {
-				setTimeout(function () {
-					t.mediaElement.renderer[methodName](args);
-				}, 150);
+				var response = t.mediaElement.renderer[methodName](args);
+				if (response && typeof response.then === 'function') {
+					response.catch(function () {
+						if (t.mediaElement.paused) {
+							setTimeout(function () {
+								var tmpResponse = t.mediaElement.renderer.play();
+								if (tmpResponse !== undefined) {
+									tmpResponse.catch(function () {
+										if (!t.mediaElement.renderer.paused) {
+											t.mediaElement.renderer.pause();
+										}
+									});
+								}
+							}, 150);
+						}
+					});
+				}
 			} else {
 				t.mediaElement.renderer[methodName](args);
@@ -995,5 +1009,5 @@
 var mejs = {};
 
-mejs.version = '4.2.5';
+mejs.version = '4.2.6';
 
 mejs.html5media = {
@@ -1563,4 +1577,5 @@
 
 		var flash = {};
+		var isActive = false;
 
 		flash.options = options;
@@ -1630,19 +1645,21 @@
 		    assignMethods = function assignMethods(methodName) {
 			flash[methodName] = function () {
-				if (flash.flashApi !== null) {
-					if (flash.flashApi['fire_' + methodName]) {
-						try {
-							flash.flashApi['fire_' + methodName]();
-						} catch (e) {
+				if (isActive) {
+					if (flash.flashApi !== null) {
+						if (flash.flashApi['fire_' + methodName]) {
+							try {
+								flash.flashApi['fire_' + methodName]();
+							} catch (e) {
+								
+							}
+						} else {
 							
 						}
 					} else {
-						
-					}
-				} else {
-					flash.flashApiStack.push({
-						type: 'call',
-						methodName: methodName
-					});
+						flash.flashApiStack.push({
+							type: 'call',
+							methodName: methodName
+						});
+					}
 				}
 			};
@@ -1716,4 +1733,12 @@
 		}
 
+		if (flash.options.streamDelimiter) {
+			flashVars.push('streamdelimiter=' + encodeURIComponent(flash.options.streamDelimiter));
+		}
+
+		if (flash.options.proxyType) {
+			flashVars.push('proxytype=' + flash.options.proxyType);
+		}
+
 		mediaElement.appendChild(flash.flashWrapper);
 		mediaElement.originalNode.style.display = 'none';
@@ -1721,9 +1746,13 @@
 		var settings = [];
 
-		if (_constants.IS_IE) {
+		if (_constants.IS_IE || _constants.IS_EDGE) {
 			var specialIEContainer = _document2.default.createElement('div');
 			flash.flashWrapper.appendChild(specialIEContainer);
 
-			settings = ['classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000"', 'codebase="//download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab"', 'id="__' + flash.id + '"', 'width="' + flashWidth + '"', 'height="' + flashHeight + '"'];
+			if (_constants.IS_EDGE) {
+				settings = ['type="application/x-shockwave-flash"', 'data="' + flash.options.pluginPath + flash.options.filename + '"', 'id="__' + flash.id + '"', 'width="' + flashWidth + '"', 'height="' + flashHeight + '\'"'];
+			} else {
+				settings = ['classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000"', 'codebase="//download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab"', 'id="__' + flash.id + '"', 'width="' + flashWidth + '"', 'height="' + flashHeight + '"'];
+			}
 
 			if (!isVideo) {
@@ -1734,8 +1763,11 @@
 		} else {
 
-			settings = ['id="__' + flash.id + '"', 'name="__' + flash.id + '"', 'play="true"', 'loop="false"', 'quality="high"', 'bgcolor="#000000"', 'wmode="transparent"', 'allowScriptAccess="' + flash.options.shimScriptAccess + '"', 'allowFullScreen="true"', 'type="application/x-shockwave-flash"', 'pluginspage="//www.macromedia.com/go/getflashplayer"', 'src="' + flash.options.pluginPath + flash.options.filename + '"', 'flashvars="' + flashVars.join('&') + '"', 'width="' + flashWidth + '"', 'height="' + flashHeight + '"'];
-
-			if (!isVideo) {
-				settings.push('style="clip: rect(0 0 0 0); position: absolute;"');
+			settings = ['id="__' + flash.id + '"', 'name="__' + flash.id + '"', 'play="true"', 'loop="false"', 'quality="high"', 'bgcolor="#000000"', 'wmode="transparent"', 'allowScriptAccess="' + flash.options.shimScriptAccess + '"', 'allowFullScreen="true"', 'type="application/x-shockwave-flash"', 'pluginspage="//www.macromedia.com/go/getflashplayer"', 'src="' + flash.options.pluginPath + flash.options.filename + '"', 'flashvars="' + flashVars.join('&') + '"'];
+
+			if (isVideo) {
+				settings.push('width="' + flashWidth + '"');
+				settings.push('height="' + flashHeight + '"');
+			} else {
+				settings.push('style="position: fixed; left: -9999em; top: -9999em;"');
 			}
 
@@ -1746,4 +1778,5 @@
 
 		flash.hide = function () {
+			isActive = false;
 			if (isVideo) {
 				flash.flashNode.style.display = 'none';
@@ -1751,4 +1784,5 @@
 		};
 		flash.show = function () {
+			isActive = true;
 			if (isVideo) {
 				flash.flashNode.style.display = '';
@@ -1815,5 +1849,9 @@
 			pseudoStreamingStartQueryParam: 'start',
 
-			pseudoStreamingType: 'byte'
+			pseudoStreamingType: 'byte',
+
+			proxyType: '',
+
+			streamDelimiter: ''
 		},
 
@@ -1925,5 +1963,5 @@
 			});
 		} else {
-			settings.options.path = typeof settings.options.path === 'string' ? settings.options.path : 'https://cdnjs.cloudflare.com/ajax/libs/flv.js/1.3.2/flv.min.js';
+			settings.options.path = typeof settings.options.path === 'string' ? settings.options.path : 'https://cdnjs.cloudflare.com/ajax/libs/flv.js/1.3.3/flv.min.js';
 
 			NativeFlv.promise = NativeFlv.promise || (0, _dom.loadScript)(settings.options.path);
@@ -1950,5 +1988,5 @@
 		prefix: 'native_flv',
 		flv: {
-			path: 'https://cdnjs.cloudflare.com/ajax/libs/flv.js/1.3.2/flv.min.js',
+			path: 'https://cdnjs.cloudflare.com/ajax/libs/flv.js/1.3.3/flv.min.js',
 
 			cors: true,
@@ -2174,5 +2212,5 @@
 			});
 		} else {
-			settings.options.path = typeof settings.options.path === 'string' ? settings.options.path : 'https://cdnjs.cloudflare.com/ajax/libs/hls.js/0.7.11/hls.min.js';
+			settings.options.path = typeof settings.options.path === 'string' ? settings.options.path : 'https://cdnjs.cloudflare.com/ajax/libs/hls.js/0.8.4/hls.min.js';
 
 			NativeHls.promise = NativeHls.promise || (0, _dom.loadScript)(settings.options.path);
@@ -2197,5 +2235,5 @@
 		prefix: 'native_hls',
 		hls: {
-			path: 'https://cdnjs.cloudflare.com/ajax/libs/hls.js/0.7.11/hls.min.js',
+			path: 'https://cdnjs.cloudflare.com/ajax/libs/hls.js/0.8.4/hls.min.js',
 
 			autoStartLoad: false,
@@ -2311,13 +2349,17 @@
 							case 'networkError':
 								if (data.details === 'manifestLoadError') {
-									if (index < total) {
+									if (index < total && mediaFiles[index + 1] !== undefined) {
 										node.setSrc(mediaFiles[index++].src);
 										node.load();
 										node.play();
+									} else {
+										var _message = 'Network error';
+										mediaElement.generateError(_message, mediaFiles);
+										console.error(_message);
 									}
 								} else {
-									var _message = 'Network error';
-									mediaElement.generateError(_message, mediaFiles);
-									console.error(_message);
+									var _message2 = 'Network error';
+									mediaElement.generateError(_message2, mediaFiles);
+									console.error(_message2);
 								}
 								break;
@@ -2467,4 +2509,5 @@
 
 		var id = mediaElement.id + '_' + options.prefix;
+		var isActive = false;
 
 		var node = null;
@@ -2501,6 +2544,8 @@
 		    assignEvents = function assignEvents(eventName) {
 			node.addEventListener(eventName, function (e) {
-				var event = (0, _general.createEvent)(e.type, e.target);
-				mediaElement.dispatchEvent(event);
+				if (isActive) {
+					var _event = (0, _general.createEvent)(e.type, e.target);
+					mediaElement.dispatchEvent(_event);
+				}
 			});
 		};
@@ -2517,4 +2562,5 @@
 
 		node.hide = function () {
+			isActive = false;
 			node.style.display = 'none';
 
@@ -2523,4 +2569,5 @@
 
 		node.show = function () {
+			isActive = true;
 			node.style.display = '';
 
@@ -2540,6 +2587,6 @@
 
 		node.addEventListener('error', function (e) {
-			if (e.target.error.code === 4) {
-				if (index < total) {
+			if (e.target.error.code === 4 && isActive) {
+				if (index < total && mediaFiles[index + 1] !== undefined) {
 					node.src = mediaFiles[index++].src;
 					node.load();
@@ -2886,7 +2933,4 @@
 				modestbranding: 0,
 				html5: 1,
-				playsinline: 0,
-				start: 0,
-				end: 0,
 				iv_load_policy: 3
 			}, youtube.options.youtube),
@@ -2918,5 +2962,5 @@
 					youTubeIframe = youTubeApi.getIframe();
 
-					if (mediaElement.originalNode.getAttribute('muted')) {
+					if (mediaElement.originalNode.muted) {
 						youTubeApi.mute();
 					}
@@ -2992,12 +3036,14 @@
 		};
 
-		if (isAudio) {
+		if (isAudio || mediaElement.originalNode.hasAttribute('playsinline')) {
 			youtubeSettings.playerVars.playsinline = 1;
 		}
 
+		if (mediaElement.originalNode.controls) {
+			youtubeSettings.playerVars.controls = 1;
+		}
 		if (mediaElement.originalNode.autoplay) {
 			youtubeSettings.playerVars.autoplay = 1;
 		}
-
 		if (mediaElement.originalNode.loop) {
 			youtubeSettings.playerVars.loop = 1;
@@ -3073,5 +3119,5 @@
 	value: true
 });
-exports.cancelFullScreen = exports.requestFullScreen = exports.isFullScreen = exports.FULLSCREEN_EVENT_NAME = exports.HAS_NATIVE_FULLSCREEN_ENABLED = exports.HAS_TRUE_NATIVE_FULLSCREEN = exports.HAS_IOS_FULLSCREEN = exports.HAS_MS_NATIVE_FULLSCREEN = exports.HAS_MOZ_NATIVE_FULLSCREEN = exports.HAS_WEBKIT_NATIVE_FULLSCREEN = exports.HAS_NATIVE_FULLSCREEN = exports.SUPPORTS_NATIVE_HLS = exports.SUPPORT_POINTER_EVENTS = exports.HAS_MSE = exports.IS_STOCK_ANDROID = exports.IS_SAFARI = exports.IS_FIREFOX = exports.IS_CHROME = exports.IS_EDGE = exports.IS_IE = exports.IS_ANDROID = exports.IS_IOS = exports.IS_IPOD = exports.IS_IPHONE = exports.IS_IPAD = exports.UA = exports.NAV = undefined;
+exports.cancelFullScreen = exports.requestFullScreen = exports.isFullScreen = exports.FULLSCREEN_EVENT_NAME = exports.HAS_NATIVE_FULLSCREEN_ENABLED = exports.HAS_TRUE_NATIVE_FULLSCREEN = exports.HAS_IOS_FULLSCREEN = exports.HAS_MS_NATIVE_FULLSCREEN = exports.HAS_MOZ_NATIVE_FULLSCREEN = exports.HAS_WEBKIT_NATIVE_FULLSCREEN = exports.HAS_NATIVE_FULLSCREEN = exports.SUPPORTS_NATIVE_HLS = exports.SUPPORT_PASSIVE_EVENT = exports.SUPPORT_POINTER_EVENTS = exports.HAS_MSE = exports.IS_STOCK_ANDROID = exports.IS_SAFARI = exports.IS_FIREFOX = exports.IS_CHROME = exports.IS_EDGE = exports.IS_IE = exports.IS_ANDROID = exports.IS_IOS = exports.IS_IPOD = exports.IS_IPHONE = exports.IS_IPAD = exports.UA = exports.NAV = undefined;
 
 var _window = _dereq_(3);
@@ -3120,4 +3166,18 @@
 }();
 
+var SUPPORT_PASSIVE_EVENT = exports.SUPPORT_PASSIVE_EVENT = function () {
+	var supportsPassive = false;
+	try {
+		var opts = Object.defineProperty({}, 'passive', {
+			get: function get() {
+				supportsPassive = true;
+			}
+		});
+		_window2.default.addEventListener('test', null, opts);
+	} catch (e) {}
+
+	return supportsPassive;
+}();
+
 var html5Elements = ['source', 'track', 'audio', 'video'];
 var video = void 0;
@@ -3226,4 +3286,5 @@
 _mejs2.default.Features.supportsNativeHLS = SUPPORTS_NATIVE_HLS;
 _mejs2.default.Features.supportsPointerEvents = SUPPORT_POINTER_EVENTS;
+_mejs2.default.Features.supportsPassiveEvent = SUPPORT_PASSIVE_EVENT;
 _mejs2.default.Features.hasiOSFullScreen = HAS_IOS_FULLSCREEN;
 _mejs2.default.Features.hasNativeFullscreen = HAS_NATIVE_FULLSCREEN;
@@ -3388,5 +3449,8 @@
 
 function visible(elem) {
-	return !!(elem.offsetWidth || elem.offsetHeight || elem.getClientRects().length);
+	if (elem.getClientRects !== undefined && elem.getClientRects === 'function') {
+		return !!(elem.offsetWidth || elem.offsetHeight || elem.getClientRects().length);
+	}
+	return !!(elem.offsetWidth || elem.offsetHeight);
 }
 
Index: /trunk/src/wp-includes/js/mediaelement/renderers/dailymotion.js
===================================================================
--- /trunk/src/wp-includes/js/mediaelement/renderers/dailymotion.js	(revision 41876)
+++ /trunk/src/wp-includes/js/mediaelement/renderers/dailymotion.js	(revision 41877)
@@ -110,5 +110,6 @@
 		var events = void 0,
 		    dmPlayer = null,
-		    dmIframe = null;
+		    dmIframe = null,
+		    muted = mediaElement.originalNode.muted;
 
 		dm.options = options;
@@ -137,5 +138,6 @@
 							return dmPlayer.ended;
 						case 'muted':
-							return dmPlayer.muted;
+							muted = dmPlayer.muted;
+							return muted;
 						case 'buffered':
 							var percentLoaded = dmPlayer.bufferedTime,
@@ -173,5 +175,9 @@
 							break;
 						case 'muted':
+							if (value === true) {
+								dmPlayer.setVolume(0);
+							}
 							dmPlayer.setMuted(value);
+							muted = value;
 							setTimeout(function () {
 								var event = mejs.Utils.createEvent('volumechange', dm);
@@ -181,4 +187,12 @@
 						case 'volume':
 							dmPlayer.setVolume(value);
+							if (value === 0 && !dmPlayer.muted) {
+								dmPlayer.setMuted(true);
+								muted = true;
+							} else if (value > 0 && dmPlayer.muted) {
+								dmPlayer.setMuted(false);
+								muted = false;
+							}
+
 							setTimeout(function () {
 								var event = mejs.Utils.createEvent('volumechange', dm);
@@ -259,6 +273,9 @@
 
 			if (mediaElement.originalNode.muted) {
+				dmPlayer.setVolume(0);
 				dmPlayer.setMuted(true);
-				dmPlayer.setVolume(0);
+			} else {
+				dmPlayer.setVolume(dmPlayer.volume);
+				dmPlayer.setMuted(false);
 			}
 
@@ -268,5 +285,5 @@
 				if (eventName !== 'ended') {
 					dmPlayer.addEventListener(eventName, function (e) {
-						var event = mejs.Utils.createEvent(e.type, dmPlayer);
+						var event = mejs.Utils.createEvent(e.type, dm);
 						mediaElement.dispatchEvent(event);
 					});
@@ -279,40 +296,40 @@
 
 			dmPlayer.addEventListener('ad_start', function () {
-				var event = mejs.Utils.createEvent('play', dmPlayer);
-				mediaElement.dispatchEvent(event);
-
-				event = mejs.Utils.createEvent('progress', dmPlayer);
-				mediaElement.dispatchEvent(event);
-
-				event = mejs.Utils.createEvent('timeupdate', dmPlayer);
+				var event = mejs.Utils.createEvent('play', dm);
+				mediaElement.dispatchEvent(event);
+
+				event = mejs.Utils.createEvent('progress', dm);
+				mediaElement.dispatchEvent(event);
+
+				event = mejs.Utils.createEvent('timeupdate', dm);
 				mediaElement.dispatchEvent(event);
 			});
 			dmPlayer.addEventListener('ad_timeupdate', function () {
-				var event = mejs.Utils.createEvent('timeupdate', dmPlayer);
+				var event = mejs.Utils.createEvent('timeupdate', dm);
 				mediaElement.dispatchEvent(event);
 			});
 			dmPlayer.addEventListener('ad_pause', function () {
-				var event = mejs.Utils.createEvent('pause', dmPlayer);
-				mediaElement.dispatchEvent(event);
-			});
-			dmPlayer.addEventListener('ad_end', function () {
-				var event = mejs.Utils.createEvent('ended', dmPlayer);
+				var event = mejs.Utils.createEvent('pause', dm);
 				mediaElement.dispatchEvent(event);
 			});
 			dmPlayer.addEventListener('start', function () {
-				if (mediaElement.originalNode.muted) {
-					dmPlayer.setMuted(true);
+				if (dmPlayer.muted) {
+					var event = mejs.Utils.createEvent('volumechange', dm);
+					mediaElement.dispatchEvent(event);
 				}
 			});
 			dmPlayer.addEventListener('video_start', function () {
-				var event = mejs.Utils.createEvent('play', dmPlayer);
-				mediaElement.dispatchEvent(event);
+				var event = mejs.Utils.createEvent('play', dm);
+				mediaElement.dispatchEvent(event);
+
+				var playingEvent = mejs.Utils.createEvent('playing', dm);
+				mediaElement.dispatchEvent(playingEvent);
 			});
 			dmPlayer.addEventListener('ad_timeupdate', function () {
-				var event = mejs.Utils.createEvent('timeupdate', dmPlayer);
+				var event = mejs.Utils.createEvent('timeupdate', dm);
 				mediaElement.dispatchEvent(event);
 			});
 			dmPlayer.addEventListener('video_end', function () {
-				var event = mejs.Utils.createEvent('ended', dmPlayer);
+				var event = mejs.Utils.createEvent('ended', dm);
 				mediaElement.dispatchEvent(event);
 
@@ -340,9 +357,13 @@
 
 		var videoId = DailyMotionApi.getDailyMotionId(mediaFiles[0].src),
-		    dmSettings = Object.assign({
+		    dmSettings = {
 			id: dm.id,
 			container: dmContainer,
 			videoId: videoId
-		}, dm.options.dailymotion);
+		};
+
+		dmSettings.params = Object.assign({}, dm.options.dailymotion);
+
+		dmSettings.params.controls = !!mediaElement.originalNode.controls;
 
 		if (mediaElement.originalNode.autoplay) {
@@ -352,4 +373,5 @@
 			dmSettings.params.mute = true;
 		}
+		dmSettings.params.api = '1';
 
 		DailyMotionApi.enqueueIframe(dmSettings);
Index: /trunk/src/wp-includes/js/mediaelement/renderers/facebook.js
===================================================================
--- /trunk/src/wp-includes/js/mediaelement/renderers/facebook.js	(revision 41876)
+++ /trunk/src/wp-includes/js/mediaelement/renderers/facebook.js	(revision 41877)
@@ -12,4 +12,28 @@
 'use strict';
 
+var FacebookApi = {
+
+	promise: null,
+
+	load: function load(settings) {
+
+		if (typeof FB !== 'undefined') {
+			FacebookApi._createPlayer(settings);
+		} else {
+			FacebookApi.promise = FacebookApi.promise || mejs.Utils.loadScript('https://connect.facebook.net/' + settings.options.lang + '/sdk.js');
+			FacebookApi.promise.then(function () {
+				FB.init(settings.options);
+
+				setTimeout(function () {
+					FacebookApi._createPlayer(settings);
+				}, 50);
+			});
+		}
+	},
+
+	_createPlayer: function _createPlayer(settings) {
+		window['__ready__' + settings.id]();
+	}
+};
 var FacebookRenderer = {
 	name: 'facebook',
@@ -19,5 +43,6 @@
 			appId: '',
 			xfbml: true,
-			version: 'v2.10'
+			version: 'v2.10',
+			lang: 'en_US'
 		}
 	},
@@ -28,18 +53,19 @@
 
 	create: function create(mediaElement, options, mediaFiles) {
-
-		var fbWrapper = {},
-		    apiStack = [],
-		    eventHandler = {},
-		    readyState = 4,
-		    autoplay = mediaElement.originalNode.autoplay;
-
-		var poster = '',
-		    src = '',
+		var apiStack = [],
+		    fb = {},
+		    readyState = 4;
+
+		var hasStartedPlaying = false,
 		    paused = true,
 		    ended = false,
-		    hasStartedPlaying = false,
-		    fbApi = null,
-		    fbDiv = null;
+		    fbPlayer = null,
+		    src = '',
+		    poster = '',
+		    autoplay = mediaElement.originalNode.autoplay;
+
+		fb.options = options;
+		fb.id = mediaElement.id + '_' + options.prefix;
+		fb.mediaElement = mediaElement;
 
 		if (mejs.Features.isiPhone && mediaElement.originalNode.getAttribute('poster')) {
@@ -48,9 +74,4 @@
 		}
 
-		options = Object.assign(options, mediaElement.options);
-		fbWrapper.options = options;
-		fbWrapper.id = mediaElement.id + '_' + options.prefix;
-		fbWrapper.mediaElement = mediaElement;
-
 		var props = mejs.html5media.properties,
 		    assignGettersSetters = function assignGettersSetters(propName) {
@@ -58,16 +79,16 @@
 			var capName = '' + propName.substring(0, 1).toUpperCase() + propName.substring(1);
 
-			fbWrapper['get' + capName] = function () {
-
-				if (fbApi !== null) {
+			fb['get' + capName] = function () {
+
+				if (fbPlayer !== null) {
 					var value = null;
 
 					switch (propName) {
 						case 'currentTime':
-							return fbApi.getCurrentPosition();
+							return fbPlayer.getCurrentPosition();
 						case 'duration':
-							return fbApi.getDuration();
+							return fbPlayer.getDuration();
 						case 'volume':
-							return fbApi.getVolume();
+							return fbPlayer.getVolume();
 						case 'paused':
 							return paused;
@@ -75,5 +96,5 @@
 							return ended;
 						case 'muted':
-							return fbApi.isMuted();
+							return fbPlayer.isMuted();
 						case 'buffered':
 							return {
@@ -98,45 +119,58 @@
 			};
 
-			fbWrapper['set' + capName] = function (value) {
-
-				if (fbApi !== null) {
+			fb['set' + capName] = function (value) {
+
+				if (fbPlayer !== null) {
 
 					switch (propName) {
 						case 'src':
 							var url = typeof value === 'string' ? value : value[0].src;
-
-							fbDiv.remove();
-							createFacebookEmbed(url, options.facebook);
+							src = url;
+
+							fbContainer.remove();
+							fbContainer = document.createElement('div');
+							fbContainer.id = fb.id;
+							fbContainer.className = 'fb-video';
+							fbContainer.setAttribute('data-href', url);
+							fbContainer.setAttribute('data-allowfullscreen', 'true');
+							fbContainer.setAttribute('data-controls', 'false');
+
+							mediaElement.originalNode.parentNode.insertBefore(fbContainer, mediaElement.originalNode);
+							mediaElement.originalNode.style.display = 'none';
+
+							FacebookApi.load({
+								lang: fb.options.lang,
+								id: fb.id
+							});
 
 							FB.XFBML.parse();
 
 							if (autoplay) {
-								fbApi.play();
+								fbPlayer.play();
 							}
-
 							break;
 						case 'currentTime':
-							fbApi.seek(value);
+							fbPlayer.seek(value);
 							break;
 						case 'muted':
 							if (value) {
-								fbApi.mute();
+								fbPlayer.mute();
 							} else {
-								fbApi.unmute();
+								fbPlayer.unmute();
 							}
 							setTimeout(function () {
-								var event = mejs.Utils.createEvent('volumechange', fbWrapper);
+								var event = mejs.Utils.createEvent('volumechange', fb);
 								mediaElement.dispatchEvent(event);
 							}, 50);
 							break;
 						case 'volume':
-							fbApi.setVolume(value);
+							fbPlayer.setVolume(value);
 							setTimeout(function () {
-								var event = mejs.Utils.createEvent('volumechange', fbWrapper);
+								var event = mejs.Utils.createEvent('volumechange', fb);
 								mediaElement.dispatchEvent(event);
 							}, 50);
 							break;
 						case 'readyState':
-							var event = mejs.Utils.createEvent('canplay', fbWrapper);
+							var event = mejs.Utils.createEvent('canplay', fb);
 							mediaElement.dispatchEvent(event);
 							break;
@@ -157,11 +191,11 @@
 		var methods = mejs.html5media.methods,
 		    assignMethods = function assignMethods(methodName) {
-			fbWrapper[methodName] = function () {
-				if (fbApi !== null) {
+			fb[methodName] = function () {
+				if (fbPlayer !== null) {
 					switch (methodName) {
 						case 'play':
-							return fbApi.play();
+							return fbPlayer.play();
 						case 'pause':
-							return fbApi.pause();
+							return fbPlayer.pause();
 						case 'load':
 							return null;
@@ -177,143 +211,137 @@
 		}
 
-		function sendEvents(events) {
+		function assignEvents(events) {
 			for (var _i2 = 0, _total2 = events.length; _i2 < _total2; _i2++) {
-				var event = mejs.Utils.createEvent(events[_i2], fbWrapper);
+				var event = mejs.Utils.createEvent(events[_i2], fb);
 				mediaElement.dispatchEvent(event);
 			}
 		}
 
-		function createFacebookEmbed(url, config) {
-			src = url;
-
-			fbDiv = document.createElement('div');
-			fbDiv.id = fbWrapper.id;
-			fbDiv.className = "fb-video";
-			fbDiv.setAttribute("data-href", url);
-			fbDiv.setAttribute("data-allowfullscreen", "true");
-			fbDiv.setAttribute("data-controls", "false");
-
-			mediaElement.originalNode.parentNode.insertBefore(fbDiv, mediaElement.originalNode);
-			mediaElement.originalNode.style.display = 'none';
-
-			window.fbAsyncInit = function () {
-
-				FB.init(config);
-
-				FB.Event.subscribe('xfbml.ready', function (msg) {
-
-					if (msg.type === 'video') {
-
-						fbApi = msg.instance;
-
-						var fbIframe = fbDiv.getElementsByTagName('iframe')[0],
-						    width = fbIframe.offsetWidth,
-						    height = fbIframe.offsetHeight,
-						    events = ['mouseover', 'mouseout'],
-						    assignEvents = function assignEvents(e) {
-							var event = mejs.Utils.createEvent(e.type, fbWrapper);
-							mediaElement.dispatchEvent(event);
-						};
-
-						fbWrapper.setSize(width, height);
-
-						if (autoplay) {
-							fbApi.play();
+		window['__ready__' + fb.id] = function () {
+			FB.Event.subscribe('xfbml.ready', function (msg) {
+				if (msg.type === 'video' && fb.id === msg.id) {
+					mediaElement.fbPlayer = fbPlayer = msg.instance;
+
+					var fbIframe = document.getElementById(fb.id),
+					    width = fbIframe.offsetWidth,
+					    height = fbIframe.offsetHeight,
+					    events = ['mouseover', 'mouseout'],
+					    assignIframeEvents = function assignIframeEvents(e) {
+						var event = mejs.Utils.createEvent(e.type, fb);
+						mediaElement.dispatchEvent(event);
+					};
+
+					fb.setSize(width, height);
+					if (!mediaElement.originalNode.muted) {
+						fbPlayer.unmute();
+					}
+
+					if (autoplay) {
+						fbPlayer.play();
+					}
+
+					for (var _i3 = 0, _total3 = events.length; _i3 < _total3; _i3++) {
+						fbIframe.addEventListener(events[_i3], assignIframeEvents);
+					}
+
+					fb.eventHandler = {};
+
+					var fbEvents = ['startedPlaying', 'paused', 'finishedPlaying', 'startedBuffering', 'finishedBuffering'];
+					for (var _i4 = 0, _total4 = fbEvents.length; _i4 < _total4; _i4++) {
+						var event = fbEvents[_i4],
+						    handler = fb.eventHandler[event];
+						if (handler !== undefined && handler !== null && !mejs.Utils.isObjectEmpty(handler) && typeof handler.removeListener === 'function') {
+							handler.removeListener(event);
 						}
-
-						for (var _i3 = 0, _total3 = events.length; _i3 < _total3; _i3++) {
-							fbIframe.addEventListener(events[_i3], assignEvents, false);
-						}
-
-						var fbEvents = ['startedPlaying', 'paused', 'finishedPlaying', 'startedBuffering', 'finishedBuffering'];
-						for (var _i4 = 0, _total4 = fbEvents.length; _i4 < _total4; _i4++) {
-							var event = fbEvents[_i4],
-							    handler = eventHandler[event];
-							if (handler !== undefined && handler !== null && !mejs.Utils.isObjectEmpty(handler) && typeof handler.removeListener === 'function') {
-								handler.removeListener(event);
+					}
+
+					if (apiStack.length) {
+						for (var _i5 = 0, _total5 = apiStack.length; _i5 < _total5; _i5++) {
+							var stackItem = apiStack[_i5];
+
+							if (stackItem.type === 'set') {
+								var propName = stackItem.propName,
+								    capName = '' + propName.substring(0, 1).toUpperCase() + propName.substring(1);
+
+								fb['set' + capName](stackItem.value);
+							} else if (stackItem.type === 'call') {
+								fb[stackItem.methodName]();
 							}
 						}
-
-						if (apiStack.length) {
-							for (var _i5 = 0, _total5 = apiStack.length; _i5 < _total5; _i5++) {
-
-								var stackItem = apiStack[_i5];
-
-								if (stackItem.type === 'set') {
-									var propName = stackItem.propName,
-									    capName = '' + propName.substring(0, 1).toUpperCase() + propName.substring(1);
-
-									fbWrapper['set' + capName](stackItem.value);
-								} else if (stackItem.type === 'call') {
-									fbWrapper[stackItem.methodName]();
-								}
-							}
+					}
+
+					assignEvents(['rendererready', 'loadeddata', 'canplay', 'progress', 'loadedmetadata', 'timeupdate']);
+
+					var timer = void 0;
+
+					fb.eventHandler.startedPlaying = fbPlayer.subscribe('startedPlaying', function () {
+						if (!hasStartedPlaying) {
+							hasStartedPlaying = true;
 						}
-
-						sendEvents(['rendererready', 'loadeddata', 'canplay', 'progress', 'loadedmetadata', 'timeupdate']);
-
-						var timer = void 0;
-
-						eventHandler.startedPlaying = fbApi.subscribe('startedPlaying', function () {
-							if (!hasStartedPlaying) {
-								hasStartedPlaying = true;
-							}
-							paused = false;
-							ended = false;
-							sendEvents(['play', 'playing', 'timeupdate']);
-
-							timer = setInterval(function () {
-								fbApi.getCurrentPosition();
-								sendEvents(['timeupdate']);
-							}, 250);
-						});
-						eventHandler.paused = fbApi.subscribe('paused', function () {
-							paused = true;
-							ended = false;
-							sendEvents(['pause']);
-						});
-						eventHandler.finishedPlaying = fbApi.subscribe('finishedPlaying', function () {
-							paused = true;
-							ended = true;
-
-							sendEvents(['ended']);
-							clearInterval(timer);
-							timer = null;
-						});
-						eventHandler.startedBuffering = fbApi.subscribe('startedBuffering', function () {
-							sendEvents(['progress', 'timeupdate']);
-						});
-						eventHandler.finishedBuffering = fbApi.subscribe('finishedBuffering', function () {
-							sendEvents(['progress', 'timeupdate']);
-						});
-					}
-				});
-			};
-
-			mejs.Utils.loadScript('https://connect.facebook.net/en_US/sdk.js');
-		}
-
-		if (mediaFiles.length > 0) {
-			createFacebookEmbed(mediaFiles[0].src, fbWrapper.options.facebook);
-		}
-
-		fbWrapper.hide = function () {
-			fbWrapper.stopInterval();
-			fbWrapper.pause();
-			if (fbDiv) {
-				fbDiv.style.display = 'none';
-			}
-		};
-		fbWrapper.show = function () {
-			if (fbDiv) {
-				fbDiv.style.display = '';
-			}
-		};
-		fbWrapper.setSize = function (width) {
-			if (fbApi !== null && !isNaN(width)) {
-				fbDiv.style.width = width;
-			}
-		};
-		fbWrapper.destroy = function () {
+						paused = false;
+						ended = false;
+						assignEvents(['play', 'playing', 'timeupdate']);
+
+						timer = setInterval(function () {
+							fbPlayer.getCurrentPosition();
+							assignEvents(['timeupdate']);
+						}, 250);
+					});
+					fb.eventHandler.paused = fbPlayer.subscribe('paused', function () {
+						paused = true;
+						ended = false;
+						assignEvents(['pause']);
+					});
+					fb.eventHandler.finishedPlaying = fbPlayer.subscribe('finishedPlaying', function () {
+						paused = true;
+						ended = true;
+
+						assignEvents(['ended']);
+						clearInterval(timer);
+						timer = null;
+					});
+					fb.eventHandler.startedBuffering = fbPlayer.subscribe('startedBuffering', function () {
+						assignEvents(['progress', 'timeupdate']);
+					});
+					fb.eventHandler.finishedBuffering = fbPlayer.subscribe('finishedBuffering', function () {
+						assignEvents(['progress', 'timeupdate']);
+					});
+				}
+			});
+		};
+
+		src = mediaFiles[0].src;
+		var fbContainer = document.createElement('div');
+		fbContainer.id = fb.id;
+		fbContainer.className = 'fb-video';
+		fbContainer.setAttribute('data-href', src);
+		fbContainer.setAttribute('data-allowfullscreen', true);
+		fbContainer.setAttribute('data-controls', !!mediaElement.originalNode.controls);
+		mediaElement.originalNode.parentNode.insertBefore(fbContainer, mediaElement.originalNode);
+		mediaElement.originalNode.style.display = 'none';
+
+		FacebookApi.load({
+			options: fb.options.facebook,
+			id: fb.id
+		});
+
+		fb.hide = function () {
+			fb.pause();
+			if (fbPlayer) {
+				fbContainer.style.display = 'none';
+			}
+		};
+		fb.setSize = function (width) {
+			if (fbPlayer !== null && !isNaN(width)) {
+				fbContainer.style.width = width;
+			}
+		};
+		fb.show = function () {
+			if (fbPlayer) {
+				fbContainer.style.display = '';
+			}
+		};
+
+		fb.destroy = function () {
 			if (poster) {
 				mediaElement.originalNode.setAttribute('poster', poster);
@@ -321,19 +349,5 @@
 		};
 
-		fbWrapper.interval = null;
-
-		fbWrapper.startInterval = function () {
-			fbWrapper.interval = setInterval(function () {
-				var event = mejs.Utils.createEvent('timeupdate', fbWrapper);
-				mediaElement.dispatchEvent(event);
-			}, 250);
-		};
-		fbWrapper.stopInterval = function () {
-			if (fbWrapper.interval) {
-				clearInterval(fbWrapper.interval);
-			}
-		};
-
-		return fbWrapper;
+		return fb;
 	}
 };
